﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace GridScrollTest
{
    public partial class Form1 : Form
    {
        string[] names = new string[] { "a", "b", "c", "d", "e" };
        DataTable parent, child;
        public Form1()
        {
            InitializeComponent();
            PlanGrid.DoubleClickCell += new DoubleClickCellEventHandler(ultraGrid1_DoubleClickCell);
            PlanGrid.DataSource = CreateDataSet();
            FillData();
        }

        void ultraGrid1_DoubleClickCell(object sender, DoubleClickCellEventArgs e)
        {
            e.Cell.Value = DBNull.Value;
            int colIndex = e.Cell.Column.Index;
            string key = e.Cell.Row.Cells["name"].Value.ToString();
            for (int i = 0; i < parent.Rows.Count; i++)
            {
                if (parent.Rows[i][0].ToString() == key)
                {
                    parent.Rows[i][colIndex] = System.DBNull.Value;
                }
            }
        }

        private void FillData()
        {
            foreach(string name in names)
            {
                DataRow parentRow = parent.NewRow();
                parentRow[0] = name;
                parent.Rows.Add(parentRow);

                for (int i = 1; i < 10; i++)
                {
                    DataRow childRow = child.NewRow();
                    childRow[0] = name;
                    childRow[i] = i;
                    child.Rows.Add(childRow);
                }
            }
        }
        
        private DataSet CreateDataSet()
        {
            DataSet set = new DataSet("parent");
            parent = new DataTable("parent");

            parent.Columns.Add("name", typeof(string));
            for (int i = 1; i < 10; i++)
            {
                parent.Columns.Add(i.ToString(), typeof(string));
            }

            child = new DataTable("child");
            child.Columns.Add("name", typeof(string));
            for (int i = 1; i < 10; i++)
            {
                child.Columns.Add(i.ToString(), typeof(string));
            }
            set.Tables.Add(parent);
            set.Tables.Add(child);
            set.Relations.Add(parent.Columns["name"], child.Columns["name"]);
            
            return set;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            PlanGrid.DisplayLayout.Bands[1].CardView = true;
        }
    }
}
